/*(c) 2006 Chritian B. Huebschle*/
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>
extern void myRender(void);
extern void myDisplay( void );
extern void myIdle( void );
extern void myNormalKey( int key, int x, int y );
extern void mySpecialKey( int key, int x, int y );
extern void myMouse( int button, int state, int x, int y );
GLuint		texture[3];
#define GLUT_KEY_ESC     27
#define GLUT_DRAG        2

#define Ato4d(arr)       arr[0], arr[1], arr[2], arr[3]
#define Ato3d(arr)       arr[0], arr[1], arr[2]

static int _win_width, _win_height;

static int _button;

void __Reshape( int width, int height ) {
  glViewport( 0, 0, _win_width=width, _win_height=height );
  printf("%d %d\n",_win_width,_win_height);
  glMatrixMode( GL_PROJECTION );
  glLoadIdentity();
  gluPerspective( betwink, (double)_win_width/_win_height, 1.0, 8000.0 );
  glMatrixMode( GL_MODELVIEW );
}
void __NormalKey( unsigned char k, int x, int y ) {
  myNormalKey( (int)k, x, y );
}
void __SpecialKey( int k, int x, int y ) {
  mySpecialKey( k, x, y );
}
void __Mouse( int button, int state, int x, int y ) {
  myMouse( _button=button, state, x, y );
}
void __Motion( int x, int y ){
  myMouse( _button, GLUT_DRAG, x, y );
}
int glutOpenWindow( int& argc, char** argv, int width, int height, const GLfloat bkcolor[]  ) {
  char s[180];
  int fenster;
  glutInitDisplayMode( GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH );
  glutInitWindowSize( _win_width=width, _win_height=height );
  glutInit( &argc, argv );
  sprintf(s,"Moliso A Program for Color Mapped Isosurfaces    %s",REV);                                                                           
  fenster=glutCreateWindow(s );
  glClearColor( Ato4d(bkcolor) );
  glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
  glEnable( GL_DEPTH_TEST );
  glEnable( GL_NORMALIZE );

  glutDisplayFunc ( myDisplay );
  
  glutIdleFunc    ( NULL );
  glutReshapeFunc ( __Reshape );
  glutKeyboardFunc( __NormalKey );
  glutSpecialFunc ( __SpecialKey );
  glutMouseFunc   ( __Mouse );
  glutMotionFunc  ( __Motion );
  return fenster;
}
void glutSetEye( const GLdouble angle, const GLdouble near_len, const GLdouble far_len, const GLdouble eye[], const GLdouble gaze[], const GLdouble up[] ) {
  gluLookAt( Ato3d(eye), Ato3d(gaze), Ato3d(up) );
}
void glutSetLight( const GLfloat position[], const GLfloat ambient[], const GLfloat diffuse[], const GLfloat specular[] ) {
  glLightModeli(  GL_LIGHT_MODEL_LOCAL_VIEWER, 1 );

  glLightfv( GL_LIGHT0, GL_POSITION, position );
  glLightfv( GL_LIGHT0, GL_AMBIENT,  ambient );
  glLightfv( GL_LIGHT0, GL_DIFFUSE,  diffuse );
  glLightfv( GL_LIGHT0, GL_SPECULAR, specular );

  glLightfv( GL_LIGHT1, GL_POSITION, position );
  glLightfv( GL_LIGHT1, GL_DIFFUSE,  diffuse );  
  glLightfv( GL_LIGHT1, GL_AMBIENT,  ambient );
  glLightfv( GL_LIGHT1, GL_POSITION, position );

  glLightfv( GL_LIGHT2, GL_DIFFUSE,  diffuse );  

  glEnable( GL_LIGHTING );
  glEnable( GL_LIGHT0 );
  glShadeModel( GL_SMOOTH );
}
inline void __RotateCS( double c, double s, double& X, double& Y ) {
  double T = X;
  X = c*X - s*Y;
  Y = s*T + c*Y;
}
void glRotateL( const double dang, const double x, const double y, const double z ) {
  double mat[4][4];
#ifndef M_PI
#define	M_PI		3.14159265358979323846	/* pi */
#endif
  const double s = sin(dang*M_PI/180);
  const double c = cos(dang*M_PI/180);

  glGetDoublev( GL_MODELVIEW_MATRIX, (double*)mat );

  if( x!=0.0 ){
    __RotateCS( c, s, mat[0][1], mat[0][2] );
    __RotateCS( c, s, mat[1][1], mat[1][2] );
    __RotateCS( c, s, mat[2][1], mat[2][2] );
  }else if( y!=0.0 ){
    __RotateCS( c, s, mat[0][2], mat[0][0] );
    __RotateCS( c, s, mat[1][2], mat[1][0] );
    __RotateCS( c, s, mat[2][2], mat[2][0] );
  }else{
    __RotateCS( c, s, mat[0][0], mat[0][1] );
    __RotateCS( c, s, mat[1][0], mat[1][1] );
    __RotateCS( c, s, mat[2][0], mat[2][1] );
  }

  glLoadMatrixd((double*)mat); 
}
void glTranslateL( const double dx, const double dy, const double dz ) {
  double mat[4][4];

  glGetDoublev( GL_MODELVIEW_MATRIX, (double*)mat );
  mat[3][0] += dx;  mat[3][1] += dy;  mat[3][2] += dz;
  glLoadMatrixd((double*)mat);
}
static FILE* __OpenConvert( const char* fname ) {
  char name[512];
  strcpy(name,fname);
  if (NULL==strstr(name,".ppm")) { strcat(name,".ppm");}
  return fopen( name, "wb" );
}
static void __CloseConvert( FILE* fptr,const char* fname  ) {
  char name[512];
  strcpy(name,fname);
  if (NULL==strstr(name,".ppm")) {
  strcat(name,".ppm");
  fclose(fptr);
#ifndef _WIN32
  char befehl[512];
  sprintf (befehl,"convert  -comment 'moliso 2.0 Christian B. Huebschle' %s %s",name,fname);
  printf("%s\n",befehl);
  system(befehl);
  sprintf (befehl,"rm %s",name);
  printf("%s\n",befehl);
  system(befehl);
#endif
  }
  else {fclose(fptr);}
}
void glutSaveWindow( const char* fname) {
  FILE* fptr = __OpenConvert(fname);
  //printf("take a screenshot\n");
  int h=(_win_height/16)*16; 
  int w=(_win_width/16)*16;
  GLuint bytes_per_line = (w)*3;
  GLubyte* image = new GLubyte [( h)*bytes_per_line ];

  GLenum Fehler;  
  const GLubyte *errString;  
  Fehler=glGetError();  
  if (Fehler!=GL_NO_ERROR) {
    errString = gluErrorString(Fehler); fprintf (stderr, "OpenGL Error: %s\n", errString); 
  }   
//  printf("OK before!");
  glReadPixels( 0, 0, w, h, GL_RGB, GL_UNSIGNED_BYTE, image );  
//  printf("OK after!");
  Fehler=glGetError();  
  if (Fehler!=GL_NO_ERROR) {
    errString = gluErrorString(Fehler); fprintf (stderr, "OpenGL Error: %s\n", errString); 
  }         

  fprintf( fptr, "P6\n%d %d\n255\n", w, h );
  for( int y=h-1; y>=0; y-- ){
    fwrite( &image[(bytes_per_line)*y], (bytes_per_line), 1, fptr );
  }
  //  fclose(fptr);

  delete [] image;

  __CloseConvert(fptr,fname);
  
  return ;//fname;
}
struct Texture {
  GLubyte* image;
  GLuint width, height;
};
int glutReadTexture( const char* ppmfname, Texture& tex ) {
  char buf[256];
  int  max=0;

  FILE* fptr = fopen( ppmfname, "rb" );
  if( fptr == NULL ){
    fprintf( stderr, "Can not open %s.\n", ppmfname );
    return 1;
  }

  fgets( buf, sizeof(buf), fptr );
  if( strncmp( buf, "P6\n", 3 ) ){
    fprintf( stderr, "Format Error!\n");
    return 1;
  }

  while( fgets( buf, sizeof(buf), fptr ) ){
    if( 2 == sscanf( buf, "%u %u", &tex.width, &tex.height ) ) break;
  }
  while( fgets( buf, sizeof(buf), fptr ) ){
    if( 1 == sscanf( buf, "%d", &max ) ) break;
  }

  long image_size = tex.width * tex.height * 3;
  tex.image = new GLubyte [image_size];
  fread( tex.image, image_size, 1, fptr );
  fclose(fptr);
  //printf("*****************Loding Texture******************\n");
  glGenTextures(2,&texture[0]);

  return 0;
}
void glutSetTexture( Texture& tex ) {
	
    glBindTexture(GL_TEXTURE_2D, texture[0]);

    glPixelStorei( GL_UNPACK_ALIGNMENT, 1 );
    glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT );
    glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT );
    glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR );
    glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR );

    glTexImage2D( GL_TEXTURE_2D, 0, 3, tex.width, tex.height, 0,
	        GL_RGB, GL_UNSIGNED_BYTE, tex.image );
    glBindTexture(GL_TEXTURE_2D,texture[2]);
	glPixelStorei( GL_UNPACK_ALIGNMENT, 1 );
    glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT );
    glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT );
    glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR );
    glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR );
	GLubyte *cs;
	cs=(GLubyte*)malloc(512*512*3*3);	
    for(int i=0;i<512;i++)
      for(int j=0;j<512;j++)
        for(int k=0;k<3;k++){
	      cs[3*512*i+3*j+k]=(GLubyte)
	      ((i==0)||((i>250)&&(i<260))||((j>250)&&(j<260))||(i==511)||(j==0)||(j==511))?0:255; 
      }		
    glTexImage2D( GL_TEXTURE_2D, 0, 3, 512, 512, 0,
	        GL_RGB, GL_UNSIGNED_BYTE, cs );

	   free(cs);
	   cs=(GLubyte*)malloc(8*256);
	   for (int i=0;i<256;i++){
       cs[4*i]= 0xff;
       cs[4*i+1]=0xff;
       cs[4*i+2]=0xff;
       cs[4*i+3]=((i/16)%2)?0xff:0x00;
	   }
		// Typical Texture Generation Using Data From The Bitmap
	  glBindTexture(GL_TEXTURE_2D, texture[1]);
	  glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT );
	  glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST );
	  glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST );
	  glTexImage2D( GL_TEXTURE_2D, 0,GL_RGBA, 16,16 , 0,
                GL_RGBA, GL_UNSIGNED_BYTE, cs );
}
void *fonts[] = {
  GLUT_BITMAP_TIMES_ROMAN_10,
  GLUT_BITMAP_HELVETICA_10,
  GLUT_BITMAP_8_BY_13,
  GLUT_BITMAP_HELVETICA_12,
  GLUT_BITMAP_9_BY_15,
  GLUT_BITMAP_HELVETICA_18,
  GLUT_BITMAP_TIMES_ROMAN_24,
};
char FontNames[7][40]= {
  "GLUT_BITMAP_TIMES_ROMAN_10",
  "GLUT_BITMAP_HELVETICA_10",
  "GLUT_BITMAP_8_BY_13",
  "GLUT_BITMAP_HELVETICA_12",
  "GLUT_BITMAP_9_BY_15",
  "GLUT_BITMAP_HELVETICA_18",
  "GLUT_BITMAP_TIMES_ROMAN_24"};
int myFont;
GLvoid BuildFont(int size) {
  size%=7;  
  myFont=size;  
  //printf("Font %d is %s\n",myFont,FontNames[myFont]);
}
GLvoid KillFont()                         // delete the font.
{
}
GLvoid glPrint(const char *text){                      // custom gl print routine.
  char *p=(char*)text;
  //  gl2psText(text,"Helvetika",13+myFont);
    while (*p!='\0') glutBitmapCharacter(fonts[myFont],*p++);
  
}




